<?xml version="1.0" encoding="ISO-8859-1"?>
<!-- Version:1.3.0 -->
	<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:html="http://www.w3.org/1999/xhtml" xmlns="http://www.w3.org/1999/xhtml" exclude-result-prefixes="html" xmlns:gba="urn:gba:sqg">
	<xsl:variable name="lowercase" select="'abcdefghijklmnopqrstuvwxyz'"/>
	<xsl:variable name="uppercase" select="'ABCDEFGHIJKLMNOPQRSTUVWXYZ'"/>

	<xsl:template match="/">
		<html xmlns="http://www.w3.org/1999/xhtml">
			<head>
				<title>Protokoll</title>
				<meta content="text/html;charset=utf-8" http-equiv="Content-Type"/>
				<meta http-equiv="X-UA-Compatible" content="IE=7"/>
				<style type="text/css"> body{font-family:sans-serif;font-size:13px}table{border-collapse:collapse;margin-top:24px;width:100%}table,#processable,#docStatus{border:1px solid #999}.hl_bg th:first-child,.hl_bg td:first-child{border-left:1px solid #999}.hl_bg th:last-child,.hl_bg td:last-child{border-right:1px solid #999}.hl_bg{background-color:#efefef}.hl_bg td{width:200px;border:1px solid #999;color:#000}td{padding:2px 10px 2px 10px}th{font-weight:normal;text-align:left;border:1px solid #999}th:first-child{border-right-style:dotted}th:last-child{border-left-style:dotted}#docStatus,th{background-color:#ddd}th{padding:8px 10px}.priority-1{font-weight:bold}.priority-2{font-weight:normal;font-style:italic}.headline{text-decoration:none}.no_decoration{font-weight:normal!important;text-decoration:none!important}.error td:last-child,.warning td:last-child,.ok td:last-child{color:#fff}.errorDoc,.error td:last-child{background-color:#ec3f3f}.warning td:last-child{background-color:#ff8d42}.warningDoc{background-color:#ff8d42}.okDoc,.ok td:last-child{background-color:#4bbc4b}.errorText{color:red}.warningText{color:orange}.okText{color:green}#content{display:inline-block;width:900px}table,#processable,#docStatus{box-shadow:2px 2px 4px #bbb}#processable{color:#fff}#processable,#docStatus{margin-bottom:15px;padding:6px}#processable span,#docStatus span{display:inline-block;width:120px}.clear{clear:both}hr{border:0;border-top:1px solid #bbb}#options{display:none;cursor:pointer;text-align:right;margin-top:15px;}div.detail{border:1px solid #bbb;background-color:#efefef;box-shadow:2px 2px 4px #ccc;padding:5px}div.detail,tr td hr{margin:15px 10px}ul li{padding-top:4px;padding-bottom:4px}div.detail p{margin:0;padding:0;background-color:inherit;border-bottom:1px solid #bbb;padding:4px}.regular{font-weight:normal}#notice{display:none;font-size:11px;color:#666}.error td,.warning td,.ok td{color:expression((this.parentNode.lastChild == this)? "#fff":"inherit")}.error td{background-color:expression((this.parentNode.lastChild == this)? "#EC3F3F":"inherit")}.warning td{background-color:expression((this.parentNode.lastChild == this)? "#FF8D42":"inherit")}.ok td{background-color:expression((this.parentNode.lastChild == this)? "#4BBC4B":"inherit")}tr td ul.document li{padding-top:expression((this.parentNode.firstChild == this)? "10px":"inherit")}tr td ul li{padding-bottom:expression((this.parentNode.lastChild == this)? "10px":"inherit")}th{border-right-style:expression((this.parentNode.firstChild == this) ? "dotted":"inherit"}th{border-right-style:expression((this.parentNode.lastChild == this) ? "dotted":"inherit"}.hg_grau{background-color:#efefef; border-bottom: 1px solid #bbb;}</style>
				<script type="text/javascript">var allOpen=false;document.getElementsByClassName=function(e){var a=this.all||this.getElementsByTagName("*");var d=new Array();var c=new RegExp("(?:^|\\s)"+e+"(?:\\s|$)");for(b in a){if(c.test(a[b].className)){d[d.length]=a[b]}}return d};function init(){var c=document.getElementsByClassName("hl_bg");for(b in c){var d=c[b];d.style.cursor="pointer";toggle(d)}var a=document.getElementById("options");a.style.display="block";document.getElementById("notice").style.display="block";bindEvent(a,"click",function(){toggleAll()},false)}function toggle(b){var a=getSiblingRow(b);toggleContentRow(a)}function toggleAll(){var c=document.getElementsByClassName("hl_bg");for(b in c){var a=getSiblingRow(c[b]);if(allOpen){a.style.display="none"}else{crossBrowser_showTableRow(a)}}allOpen=!allOpen}function bindEvent(c,a,b){if(c.addEventListener){c.addEventListener(a,b,false)}else{if(c.attachEvent){c.attachEvent("on"+a,b)}}}function getSiblingRow(b){var a=b.nextSibling;while(a){if(a.nodeType==1){return a;break}a=a.nextSibling}return null}function toggleContentRow(a){if(a.style.display!="none"){a.style.display="none"}else{crossBrowser_showTableRow(a)}}function crossBrowser_showTableRow(b){try{b.style.display="table-row"}catch(a){b.style.display=""}}function toggleTBody(){var a = document.getElementsByTagName("tbody");if(a[0].style.display!="none"){a[0].style.display="none"}else{a[0].style.display="table-row-group"}};</script>
			</head>
			<body onload="init()">
				<div id="content">
					<xsl:apply-templates select="gba:root/gba:header/gba:protocol/gba:status_document"/>
					<table>
						<thead>
							<th colspan="6" onclick="toggleTBody()" style="cursor: pointer;"> Verarbeitete Datenstze je Datencontainer</th>
						</thead>
						<tbody style="display:table-row-group; text-align:center; ">
							<tr style="background-color:#efefef; border-bottom: 1px solid #bbb; ">
								<td>Modul</td>
								<td>gesamt</td>
								<td>create</td>
								<td>update</td>
								<td>delete</td>
								<td>corrupted</td>
							</tr>
							<xsl:apply-templates select="gba:root/gba:body/gba:data_container/gba:cases"/>
						</tbody>
					</table>
					<div id="options"> Validierungsdetails ein/aus</div>
					<xsl:apply-templates select="gba:root/gba:header/gba:protocol/gba:validation_provider"/>
					<br/>
					<span id="notice">Details einzelner Validation-Items knnen duch Klicken auf das jeweilige Element angezeigt oder ausgeblendet werden.</span>
				</div>
			</body>
		</html>
	</xsl:template>

	<xsl:template match="gba:status_document">
		<div class="{concat(translate(@V, $uppercase, $lowercase), 'Doc')}" id="processable">
			<span>Dokument-Status:</span>
			<xsl:value-of select="@V"/>
		</div>
	</xsl:template>
	
	<xsl:template match="gba:validation_provider">
		<table>
			<tr>
				<th colspan="2">
					<span class="priority-1">
						<xsl:choose>
							<xsl:when test="string-length(@function) &gt; 0">
								<xsl:value-of select="@function"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="'Unbekannte Funktion'"/>
							</xsl:otherwise>
						</xsl:choose>
					</span>
					<br/>
					<span class="priority-1">
						<xsl:choose>
							<xsl:when test="string-length(@name) &gt; 0">
								<xsl:value-of select="@name"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="'Unbekannter Provider'"/>
							</xsl:otherwise>
						</xsl:choose>
					</span>

					<xsl:choose>
						<xsl:when test="string-length(@function) &gt; 0">
					(<xsl:value-of select="@registration"/>)<br/>
						</xsl:when>
						<xsl:otherwise>
						</xsl:otherwise>
					</xsl:choose>

					<xsl:value-of select="@address"/>
				</th>
				<th colspan="2">tel: 
						<xsl:choose>
							<xsl:when test="string-length(@phone) &gt; 0">
								<xsl:value-of select="@phone"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="'-'"/>
							</xsl:otherwise>
						</xsl:choose>
					<br/>fax: 
						<xsl:choose>
							<xsl:when test="string-length(@fax) &gt; 0">
								<xsl:value-of select="@fax"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="'-'"/>
							</xsl:otherwise>
						</xsl:choose>
					<br/>
						<xsl:choose>
							<xsl:when test="string-length(@email) &gt; 0">
								<xsl:value-of select="@email"/>
							</xsl:when>
							<xsl:otherwise>
							</xsl:otherwise>
						</xsl:choose>
				</th>
			</tr>
			<xsl:apply-templates select="gba:validation_item"/>
		</table>
	</xsl:template>

	<xsl:template match="gba:validation_item">
		<xsl:variable name="id" select="@id"/>
		<xsl:variable name="cases_with_errors" select="//gba:case/gba:case_admin/gba:protocol/gba:validation_item[@id = $id]/gba:status/gba:error/ancestor::gba:case"/>

		<tr class="hl_bg {translate(gba:status/@V, $uppercase, $lowercase)}" onclick="toggle(this)">
			<td>Validierung <xsl:value-of select="@id"/>
			</td>
			<td>
				<xsl:value-of select="@c_date"/>
			</td>
			<td>
				<xsl:value-of select="@V"/>
			</td>
			<td>
				<xsl:value-of select="gba:status/@V"/>
			</td>
		</tr>
		<tr>
			<td colspan="4">
				<xsl:choose>
					<xsl:when test="gba:status/gba:error or $cases_with_errors">
						<xsl:if test="gba:status/gba:error">
							<div class="detail">
								<ul class="document">
									<xsl:apply-templates select="gba:status/gba:error"/>
								</ul>
							</div>
						</xsl:if>
						<xsl:if test="gba:status/gba:error and $cases_with_errors">
							<hr/>
						</xsl:if>
						<xsl:if test="$cases_with_errors">
							<xsl:apply-templates select="$cases_with_errors">
								<xsl:with-param name="id" select="$id"/>
							</xsl:apply-templates>
						</xsl:if>						
					</xsl:when>
					<xsl:otherwise>
						<div class="detail">Validierung erfolgreich</div>
					</xsl:otherwise>
				</xsl:choose>
			</td>
		</tr>
	</xsl:template>

	<xsl:template match="gba:error">
		<li>
			<span class="bold">
				<xsl:value-of select="gba:error_message/@V"/>
			</span>
			<br/>
			<xsl:if test="gba:error_type">
				Art: <span class="bold">
					<xsl:value-of select="gba:error_type/@V"/>
				</span>
			</xsl:if>
			<xsl:choose>
				<xsl:when test="gba:rule_id and gba:rule_type">
					 (Regel-ID: <span class="bold">
						<xsl:value-of select="gba:rule_id/@V"/>
					</span> | Regel-Typ: <span class="bold">
						<xsl:value-of select="gba:rule_type/@V"/>
					</span>)
				</xsl:when>
				<xsl:when test="gba:rule_id and not(gba:rule_type)">
					 (Regel-ID: <span class="bold">
						<xsl:value-of select="gba:rule_id/@V"/>
					</span>)
				</xsl:when>
				<xsl:when test="not(gba:rule_id) and gba:rule_type">
					 (Regel-Typ: <span class="bold">
						<xsl:value-of select="gba:rule_type/@V"/>
					</span>)
				</xsl:when>
				<xsl:otherwise>
				</xsl:otherwise>
			</xsl:choose>
		</li>
	</xsl:template>

	<xsl:template match="gba:case">
		<xsl:param name="id"/>
		<xsl:if test="not(gba:case_admin/gba:protocol/gba:status_case/@V = 'OK')">
			<div class="detail">
				<p>Vorgang <span class="priority-1">
						<xsl:value-of select="gba:case_admin/gba:id/@V"/>
					</span> (Status: <span class="priority-2">
						<xsl:value-of select="gba:case_admin/gba:protocol/gba:status_case/@V"/>
					</span>)</p>
				<ul>
					<xsl:apply-templates select="gba:case_admin/gba:protocol/gba:validation_item[@id = $id]/gba:status/gba:error"/>
				</ul>
			</div>
		</xsl:if>
	</xsl:template>
	
	<xsl:template match="gba:cases">
		<xsl:variable name="processed_corrupted" select="gba:statistic/gba:processed/gba:corrupted/@V"/>
		<tr style="border-bottom: 1px solid #bbb; ">				
			<td><xsl:value-of select="@module"/></td>
			<td><xsl:value-of select="gba:statistic/gba:processed/@count"/></td>
			<td><xsl:value-of select="gba:statistic/gba:processed/gba:create/@V"/></td>
			<td><xsl:value-of select="gba:statistic/gba:processed/gba:update/@V"/></td>
			<td><xsl:value-of select="gba:statistic/gba:processed/gba:delete/@V"/></td>
			<xsl:choose>
				<xsl:when test="$processed_corrupted > 0">
					<td style="background-color:#ec3f3f; color:white; font-weight:bold; ">
						<xsl:value-of select="$processed_corrupted"/>
					</td>
				</xsl:when>
				<xsl:otherwise>
					<td>
						<xsl:value-of select="$processed_corrupted"/>
					</td>
				</xsl:otherwise>
			</xsl:choose>
		</tr>
	</xsl:template>
</xsl:stylesheet>